from yum.rpmtrans import RPMBaseCallback

class TransactionCallBack(object):
	"""docstring for TransactionCallBack"""
	def __init__(self):
		pass
	
	def event(self,state,data=None):
		"""Handle an event by logging it.

		:param state: a number indicating the type of callback
		:param data: data associated with the callback
	 	"""
		print 'callback state: %s' % (state,)
		print 'callback data: %s' % (str(data),)

class RPMCallBack(RPMBaseCallback):
	def __init__(self,status_updater = None, _gui = None):
		RPMBaseCallback.__init__(self)
		self.lastmsg = None
		self.lastpackage = None # name of last package we looked at
		self.status_updater = status_updater
		self._gui = _gui
		
	def event(self, package, action, te_current, te_total, ts_current, ts_total):
		# this is where a progress bar would be called
		msg = '%s: %s %s/%s [%s/%s]' % (self.action[action], package, 
								te_current, te_total, ts_current, ts_total)
		if msg != self.lastmsg and package != self.lastpackage:
			installation_status = {
				'action':'installing_packages',
				'detail':{'package':str(package),'action':str(action)},
				'progress':{'current':ts_current,'total':ts_total}
			}
			if self.status_updater:
				self.status_updater.update_status(installation_status)
			print msg
			if self._gui:
				self._gui.update_progress(installation_status)
		self.lastmsg = msg
		self.lastpackage = package

	def scriptout(self, package, msgs):
		if msgs:
			print msgs,

	def verify_txmbr(self, base, txmbr, count):
		" Callback for post transaction when we are in verifyTransaction(). "
		print _("Verify: %u/%u: %s") % (count, len(base.tsInfo), txmbr)