import sys,re,getopt
from StringIO import StringIO
import ksparse

ks_path = None
ks = None
text_mode = False
public_installation = False
api_base = None
network_type = 'lan'
no_reboot = False
reboot_button_pressed = False
cpu_check=True

def parse_cmdline():
	global ks_path,text_mode,public_installation,api_base,network_type,no_reboot,cpu_check
	"""docstring for parse_cmdline"""
	f = open('/proc/cmdline')
	cmdline = f.read()
	f.close()
	
	mymatch = re.match('.*\sinst.ks=([^ ]+)', cmdline)
	if mymatch != None:
		ks_path = mymatch.group(1)
	else:
		pass
	mymatch = re.match('.*\sinst.api_base=([^ ]+)', cmdline)
	if mymatch != None:
		api_base = mymatch.group(1).strip()
	else:
		pass
	mymatch = re.match('.*\sinst.network_type=([^ ]+)', cmdline)
	if mymatch != None:
		network_type = mymatch.group(1)
	else:
		pass
	mymatch = re.match('.*\sinst.text(\s|$)', cmdline)
	if mymatch != None:
		text_mode = True
	else:
		pass
	mymatch = re.match('.*\sinst.public(\s|$)', cmdline)
	if mymatch != None:
		public_installation = True
	else:
		pass
	mymatch = re.match('.*\sinst.no_reboot(\s|$)', cmdline)
	if mymatch != None:
		no_reboot = True
	else:
		pass
	mymatch = re.match('.*\sinst.no_cpu_check(\s|$)', cmdline)
	if mymatch != None:
		cpu_check = False
	else:
		pass
	opts,args = getopt.getopt(sys.argv[1:],'',['ks=','window','text', 'public=','api_base=','network_type=','no_reboot','no_cpu_check'])
	for opt in opts:
		if opt[0] == '--ks':
			ks_path = opt[1]
		elif opt[0] == '--text':
			text_mode = True
		elif opt[0] == '--no_reboot':
			no_reboot = True
		elif opt[0] == '--no_cpu_check':
			cpu_check = False
		elif opt[0] == '--public':
			public_installation = opt[1]
		elif opt[0] == '--api_base':
			api_base = opt[1]
		elif opt[0] == '--network_type':
			network_type = opt[1]
			
def parse_kickstart(data=None):
	global ks,ks_path
	if data == None and ks_path != None:
		ks = ksparse.parseFile(ks_path)
		return True
	elif data != None:
		buf = StringIO(data)
		ks = ksparse.parse(buf)
		return True
	else:
		raise Exception('No kickstart data available!')
		
	