import requests,json
from base64 import b64encode

class RemoteApi(object):
	"""docstring for RemoteApi"""
	def __init__(self,api_base_address,params=None,name=None):
		self._api_base_address = api_base_address
		self._name = name
		if params == None:
			self._params = {'sid':None}
		else:
			self._params = params
	
	def use_sid(self,sid):
		"""docstring for use_sid"""
		previous_sid = self._params['sid']
		self._params['sid'] = sid
		try:
			ret = self.__getattr__('is_logged')()
			if ret == True:
				return True
		except:
			pass
		self._params['sid'] = previous_sid
		return False
		
	def login(self,uuid_bytes,api_key):
		"""docstring for login"""
		try:
			login = self.__getattr__('login')(b64encode(uuid_bytes),b64encode(api_key))
		except:
			
			return False
		self._params['sid'] = login['sid']
		return True
	
	def logout(self):
		"""docstring for logout"""
		ret = self.__getattr__('logout')()
		self._params['sid'] = None
		return True
	
	def __getattr__(self, name):
		attr = type(self)(self._api_base_address,self._params,name)
		return attr.__call__
	
	def __call__(self, *args):
		"""Call method on server. handle pickling possible encryption"""
		call_data = {'fn': self._name,'args':json.dumps(args)}
		if self._sid != None:
			call_data['sid'] = self._params['sid']
		if call_data['fn'] == 'installation_update_status':
			timeout = 20
		else:
			timeout = None
		try:
			r = requests.post(self._api_base_address,data=call_data,timeout=timeout)
		except requests.Timeout:
			return None
		
		if r.status_code == requests.codes.ok:
			try:
				return r.json()
			except:
				print r.content
				raise
		else:
			raise Exception('Function %s returned error code %s with text: %s' % (self._name,r.status_code,r.content))

