from threading import Thread
import cPickle as pickle
import time

class StatusUpdater(Thread):
	"""docstring for StatusUpdater"""
	def __init__(self, api, gui, installation_status={'action':'before_start','progress':None}):
		super(StatusUpdater, self).__init__()
		self._api = api
		self._gui = gui
		self.daemon = True
		self._exit = False
		self._installation_status = installation_status
		self._last_sent_status = None
		self._progress = None
	
	def update_status(self,installation_status,progress=None):
		"""docstring for update_status"""
		self._installation_status = installation_status
		self._progress = progress
	
	def run(self):
		"""docstring for run"""
		while not self._exit:
			try:
				if self._progress != None:
					self._api.installation_update_status({'action':self._installation_status['action'],'progress':self._progress()})
				elif self._last_sent_status != pickle.dumps(self._installation_status):
					self._api.installation_update_status(self._installation_status)
					self._last_sent_status = pickle.dumps(self._installation_status)
				time.sleep(5)
			except Exception as ex:
				# retry
				time.sleep(0.1)
				pass

	def stop(self):
		"""docstring for stop"""
		self._exit = True
		