#!/usr/bin/python

archs = ['noarch', 'x86_64']
import os
import yum,rpm
from yum.Errors import RepoError

class YumUtil():
	def __init__():
		self.yb = yum.YumBase()
	
	def depPackages(self,pattern):
		pkg = self.yb.pkgSack.returnNewestByNameArch(patterns=[pattern])
		return self.check_deps(pkg)

	def check_deps(self,packages):
		resolved = set()
		dep_pkgs = packages
		while dep_pkgs != []:
			packages = list(dep_pkgs)
			# exclude resolved
			for pkg in packages:
				if pkg in resolved:
					dep_pkgs.remove(pkg)
			packages = list(dep_pkgs)
			deps = self.yb.findDeps(packages)
			for pkg in packages:
				dep_pkgs.remove(pkg)
				resolved.add(pkg)
				for dep in deps[pkg].keys():
					for dpkg in deps[pkg][dep]:
						if dpkg.arch in archs and dpkg not in resolved:
							dep_pkgs.append(dpkg)
		return resolved

	def download(self,toDownload,destdir):
		for pkg in toDownload:
			n,a,e,v,r = pkg.pkgtup
			packages =  self.yb.pkgSack.searchNevra(n,e,v,r,a)
			packages.sort()
			last = None
			for download in packages:
				if download.pkgtup == last :
					continue
				last = download.pkgtup
				repo = self.yb.repos.getRepo(download.repoid)
				remote = download.returnSimple('relativepath')
				local = os.path.basename(remote)
				if not os.path.exists(destdir):
					os.makedirs(destdir)
				local = os.path.join(destdir, local)
				if (os.path.exists(local) and
					os.path.getsize(local) == int(download.returnSimple('packagesize'))):
					continue
				# Disable cache otherwise things won't download
				repo.cache = 0
				download.localpath = local # Hack: to set the localpath we want.
				try:
					path = repo.getPackage(download)
				except IOError, e:
					print ("Cannot write to file %s. Error was: %s" % (local, e))
					exit_code = 2
					continue
				except RepoError, e:
					print ("Could not download/verify pkg %s: %s" % (download, e))
					exit_code = 2
					continue
	
				if not os.path.exists(local) or not os.path.samefile(path, local):
		#			progress = TextMeter()
		#			progress.start(basename=os.path.basename(local),
		#						   size=os.stat(path).st_size)
					shutil.copy2(path, local)
		#			progress.end(progress.size)

		
