# mame autoreinstall?
NEWHOSTNAME=`cat /proc/cmdline | egrep -o 'c2p\.hostname=[a-z0-9\.\-]+' | awk -F= '{print $2}'`
if [ "$NEWHOSTNAME" != "" ]; then
	cat > /root/setup-defaults.cfg <<EOF
NEWHOSTNAME=$NEWHOSTNAME
IPV4=`host -i $NEWHOSTNAME | grep 'has address' | awk '{print $4}'`
IPV6=`host -i $NEWHOSTNAME | grep 'has IPv6 address' | awk '{print $5}'`
UNATTENDED=1
EOF
chmod +x /etc/rc.d/rc.local
cat >> /etc/rc.d/rc.local <<EOF
sh /root/setup.sh >> ~/setup.log 2>&1
EOF
touch /root/.autoreinstall
fi

# normalizovat rozlozeni disku

currentpv=/dev/`lvs --noheadings -o lv_name,devices | egrep -o md[0-9]+|head -n1`
for pv in `pvs -o pv_name --noheadings`; do lvs -o devices --noheadings | grep $pv > /dev/null || (
	vgreduce HostVG $pv
	mdadm --stop $pv
)
done
bootmd=`mount | grep /boot | awk '{print $1}'`
umount /boot
mdadm --stop $bootmd
mdadm -A /dev/md1 /dev/sd[abcdef]2
mount /dev/md1 /boot
for i in c d e f; do
	blkdiscard /dev/sd${i}3 && (
		touch /root/.has_discard_capability
		touch /root/.has_discard_capability.sd$i
		OO=0
		BS=$((1024*1024*1024))
		while blkdiscard -o $OO -l $BS /dev/sd${i}3 2>/dev/null; do
			OO=$(($OO+$BS))
		done
	)
done
if [ -f /root/.has_discard_capability.sdc -a -f /root/.has_discard_capability.sdd ]; then
	assumeclean="--assume-clean"
fi
mdadm -C /dev/md3 -f -R -l10 -n2 -p f2 --bitmap none -e 1 $assumeclean /dev/sd[cd]3
if [ -f /root/.has_discard_capability.sde -a -f /root/.has_discard_capability.sdf ]; then
	assumeclean="--assume-clean"
fi
mdadm -C /dev/md4 -f -R -l10 -n2 -p f2 --bitmap none -e 1 $assumeclean /dev/sd[ef]3

# zpomalit resync na dobu instalace
for i in 1 3 4; do echo frozen > /sys/block/md$i/md/sync_action; done

vgextend HostVG /dev/md[34]

swapoff -a

lvremove -f HostVG/swap

pvmove $currentpv /dev/md3:200000-300000
#lvresize -l54614 HostVG/root /dev/md3
#lvresize -l109228 HostVG/root /dev/md4

vgreduce HostVG $currentpv
mdadm --stop $currentpv
for i in a b; do
	blkdiscard /dev/sd${i}3 && (
		touch /root/.has_discard_capability
		touch /root/.has_discard_capability.sd$i
		OO=0
		BS=$((1024*1024*1024))
		while blkdiscard -o $OO -l $BS /dev/sd${i}3 2>/dev/null; do
			OO=$(($OO+$BS))
		done
	)
done
if [ -f /root/.has_discard_capability.sda -a -f /root/.has_discard_capability.sdb ]; then
	assumeclean="--assume-clean"
fi
mdadm -C /dev/md2 -f -R -l10 -n2 -p f2 --bitmap none -e 1 $assumeclean /dev/sd[ab]3

# zpomalit resync na dobu instalace
echo frozen > /sys/block/md2/md/sync_action

vgextend HostVG /dev/md2

#lvresize -l163842 HostVG/root /dev/md2

#xfs_growfs /dev/HostVG/root

#lvcreate -L10G -n swap -i3 -I1M HostVG </dev/null

#mkswap -f /dev/HostVG/swap

mdadm -D --scan > /etc/mdadm.conf
echo "MAILADDR root" >> /etc/mdadm.conf

mount -a

mount

dracut --force

mduuid=`mdadm -D --scan | egrep -o UUID=.* | awk -F= '{print "rd.md.uuid=" $2}' | xargs echo`
sed -i "/linux16/s/rd\.md\.uuid=[^ ]\+ //g;s/.*linux16.*/\0 $mduuid/" /boot/grub2/grub.cfg


# konec normalizace


for i in b c d e f; do
	grub2-install /dev/sd$i
done

mkdir /mnt/install

setenforce 0
sed -i 's/^SELINUX=.*/SELINUX=disabled/' /etc/sysconfig/selinux
sed -i 's/^SELINUX=.*/SELINUX=disabled/' /etc/selinux/config
chkconfig libvirt-guests on

sed -i 's/PasswordAuthentication yes/PasswordAuthentication no/g' /etc/ssh/sshd_config
sed -i 's/#relayhost = \$mydomain/relayhost = smtp.hosting90.cz/' /etc/postfix/main.cf
chkconfig postfix on

echo "StrictHostKeyChecking no" >> /etc/ssh/ssh_config
echo "UserKnownHostsFile /dev/null" >> /etc/ssh/ssh_config
sed -i 's#^\s\+filter =.*$#\tfilter = [ "a|/dev/md.+|", "a|/dev/mapper/temp-.*|", "r/.*/" ]#' /etc/lvm/lvm.conf
if [ -f /root/.has_discard_capability ]; then
	sed -i 's#^(\s*)issue_discards.*#\1issue_discards = 1#' /etc/lvm/lvm.conf
fi
wget http://mirror.hosting90.cz/cloud2private/install_data/setup.sh -O /root/setup.sh
cd /root
echo 'export HISTTIMEFORMAT="%d/%m/%y %T "' >> /root/.bash_profile
svn co svn://svn.hosting90.cz/autohosting server

echo  "239.0.0.0/8 dev bond0.2" > /etc/sysconfig/network-scripts/route-bond0.2
echo -e "DEVICE=bond0\nUSERCTL=no\nBOOTPROTO=static\nONBOOT=yes\nBONDING_OPTS='mode=balance-rr miimon=100'\nMTU=9000\nNOZEROCONF=yes" > \
  /etc/sysconfig/network-scripts/ifcfg-bond0
echo -e "DEVICE=bond0.2\nONBOOT=yes\nMTU=9000\nVLAN=yes\nNOZEROCONF=yes" > \
  /etc/sysconfig/network-scripts/ifcfg-bond0.2
for iface in `cat /proc/net/dev | tail -n+3 | awk -F: '{print $1}' | grep -v lo | grep -v bond0 | grep -v lo`; do
	echo -e "DEVICE=$iface\nTYPE=Ethernet\nBOOTPROTO=none\nONBOOT=yes\nMASTER=bond0\nSLAVE=yes\nUSERCTL=no\nMTU=9000\nNOZEROCONF=yes" > \
	  /etc/sysconfig/network-scripts/ifcfg-$iface
done
echo "NOZEROCONF=yes" >> /etc/sysconfig/network

cat >> /root/.bashrc << EOF
EDITOR=vim
if [ ! -f /etc/sysconfig/network-scripts/ifcfg-vbr100 ] && [ ! -f /etc/sysconfig/network-scripts/ifcfg-vbr101 ]; then
	/bin/sh setup.sh
fi
EOF

echo 'CREATE_DEFAULT=yes' > /etc/sysconfig/cgconfig

echo 'dev.raid.speed_limit_min = 4
kernel.core_uses_pid = 1
kernel.msgmax = 65536
kernel.msgmnb = 65536
kernel.panic = 3
kernel.panic_on_oops = 1
kernel.pid_max = 8192
kernel.shmall = 1073741824
kernel.shmmax = 268435456
kernel.sysrq = 1
kernel.sched_migration_cost = 5000000
kernel.sched_min_granularity_ns = 10000000
kernel.sched_wakeup_granularity_ns = 15000000
net.bridge.bridge-nf-call-arptables = 0
net.bridge.bridge-nf-call-ip6tables = 0
net.bridge.bridge-nf-call-iptables = 0
net.core.rmem_default = 524288
net.core.wmem_default = 524288
net.core.rmem_max = 524288
net.core.wmem_max = 524288
net.core.netdev_max_backlog = 2000
net.core.netdev_budget = 400
net.ipv4.conf.default.arp_filter = 1
net.ipv4.conf.default.accept_source_route = 0
net.ipv4.conf.default.rp_filter = 0
net.ipv4.conf.all.rp_filter = 0
net.ipv4.conf.vbr100.rp_filter = 0
net.ipv4.conf.vbr100.arp_filter = 0
net.ipv4.ip_forward = 0
net.ipv4.tcp_syncookies = 0
vm.dirty_background_ratio = 5
vm.dirty_ratio = 10
vm.vfs_cache_pressure = 300
vm.zone_reclaim_mode = 2
vm.swappiness = 0
vm.extfrag_threshold = 200
vm.min_free_kbytes = 262144' > /etc/sysctl.conf

echo 'KSM_MONITOR_INTERVAL=90
KSM_SLEEP_MSEC=18
KSM_NPAGES_BOOST=300
KSM_NPAGES_DECAY=-50
KSM_NPAGES_MIN=64
KSM_NPAGES_MAX=1250
KSM_THRES_COEF=20
KSM_THRES_CONST=8192
LOGFILE=/var/log/ksmtuned
DEBUG=0' > /etc/ksmtuned.conf

echo 'DRIVER=acpi-cpufreq
GOVERNOR=performance
VMAJOR=1
VMINOR=1' > /etc/sysconfig/cpuspeed

echo 'BUS_MODULES="ipmi-si"
HWMON_MODULES="coretemp"
MODULE_0=ipmi-si
MODULE_1=coretemp
MODULE_2=w83795' > /etc/sysconfig/lm_sensors

echo '#!/bin/sh

modprobe ipmi_devintf

exit 0
' > /etc/sysconfig/modules/ipmi.modules
chmod 0755 /etc/sysconfig/modules/ipmi.modules

sed -i '/^Defaults\s\+requiretty/s/^/#/' /etc/sudoers
echo 'nrpe  ALL=(root) NOPASSWD: /usr/bin/ipmitool, /usr/bin/yum history list all, /usr/sbin/smartctl -a *, /sbin/lvs' >> /etc/sudoers

echo 'options e1000e SmartPowerDownEnable=0 IntMode=2 InterruptThrottleRate=3000,3000,3000' > /etc/modprobe.d/e1000e.conf
echo 'options vhost_net experimental_zcopytx=1' >  /etc/modprobe.d/vhost-net.conf

echo admin@hosting90.cz > /root/.forward

cat > /etc/sysconfig/raid-check << "EOF"
#!/bin/bash
ENABLED=no
CHECK=check
NICE=low
CHECK_DEVS=""
REPAIR_DEVS=""
SKIP_DEVS=""
EOF

wget http://mirror.hosting90.cz/cloud2private/install_data/virtualization-h90-c7.tgz -O /usr/lib/tuned/virtualization-h90.tgz
cd /usr/lib/tuned
tar zxf virtualization-h90.tgz
rm -f virtualization-h90.tgz
tuned-adm profile virtualization-h90
cd
ntpdate ns1.hosting90.cz
hwclock -w
chkconfig ntpd on
chkconfig tuned on
chkconfig auditd on

yum -y install /root/server/virtual/rfoo-1.3.0-1-el7.x86_64.rpm /root/server/command/h90util/python-h90util-0.1-1-el7.x86_64.rpm

yum -y install https://kojipkgs.fedoraproject.org//packages/python-lzo/1.08/15.fc22/x86_64/python-lzo-1.08-15.fc22.x86_64.rpm
yum -y install https://kojipkgs.fedoraproject.org//packages/bwm-ng/0.6/16.fc22/x86_64/bwm-ng-0.6-16.fc22.x86_64.rpm https://kojipkgs.fedoraproject.org//packages/libstatgrab/0.17/4.el7.2/x86_64/libstatgrab-0.17-4.el7.2.x86_64.rpm

rm -f /etc/munin/plugins/yum
cat > /etc/munin/plugin-conf.d/diskstats <<EOF
[diskstats]
user root
env.include_only sda,sdb,sdc,sdd,sde,sdf,sdg,sdh,sdi,sdj,sdk
EOF
cat > /etc/munin/plugin-conf.d/diskstats <<EOF
[diskstats]
user root
env.include_only sda,sdb,sdc,sdd,sde,sdf,sdg,sdh,sdi,sdj,sdk
EOF
cat > /etc/munin/plugin-conf.d/iostat <<EOF
[iostat_ios]
user root
EOF

sed -i 's/^installonly_limit=.*$/installonly_limit=3/' /etc/yum.conf
systemctl disable NetworkManager.service
systemctl disable firewalld.service
# kvuli logovani a dohledani ip adresy
ip a show

